/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/****  Project : eXtended C Library (XCLIB)
    *  Purpose : XCLIB INTERNALS
    *  Language: ANSI C
    *  File    : demo_config.c
    *  Author  : Martin Vicente <martin@vicente.org>
    *
    ****/


/*****************************************************************************\

 [English]

 Caution: The header file <xc/config.h> only reports on the particularities of
 the system where the XC library is installed on. The library - which is aimed
 to alleviate the considered system's environnement failures - has no reason to
 export directly this file. Therefore the header file <xc/config.h> is not
 included in <xclib.h>.

 Of course, it is used to build XCLIB; however, nothing forbids to also use it:
 Some specifics needs of your project may require it. That the really reason
 why it had been kept accessible in this place.

 To be really useful, it should be included before any other header file.

 <xc/config.h> exists because of Autoconf (David MacKenzie); itself built on
 the sh and m4 standards.

 [French]
 
 Attention: Le fichier d'en-tte <xc/config.h> rend compte uniquement des
 particularits du systme sur lequel la bibliothque XC a t installe.
 Cette dernire - ayant aussi pour objectif de pallier les dfaillances de
 l'environnement du systme considr - n'a pas de raison d'exporter
 directement ce fichier. C'est pour cette raison que le fichier d'en-tte
 <xc/config.h> n'est pas inclus dans <xclib.h>.

 Bien sr, il est mis  profit lors de la fabrication de XCLIB; cependant,
 rien ne vous interdit de l'utiliser galement: des besoins spcifiques  votre
 projet peuvent le rendre utile. C'est exactement pour cela qu'il a t laiss
 accessible  cet endroit.
 En fonction des besoins ou des demandes, il pourra tre largement augment.

 Pour qu'il puisse remplir pleinement son office, il devra tre inclus avant
 tout autre fichier d'en-tte.
 
 <xc/config.h> doit essentiellement son existence  Autoconf (David MacKenzie);
 lui-mme construit sur les standards sh et m4.

\*****************************************************************************/


#include <xc/config.h>

#ifdef HAVE_STDINT_H
#include <stdint.h>
#else
#include <limits.h>
#endif
#include <stdio.h>

#ifndef SIZE_MAX
#define SIZE_MAX	UINT_MAX
#endif

int main()
{
#ifdef __CHAR_UNSIGNED__
    puts("This compiler have unsigned char");
#else
    puts("This compiler have signed char");
#endif

    printf("size of int : %u\n", SIZEOF_INT);

    printf("SIZE_MAX = %lu\n", (unsigned long int)(SIZE_MAX));

#ifdef HAVE_ALLOCA_H
    puts("This environment have <alloca.h>");
#else
    puts("This environment have not <alloca.h>");
#endif
#ifdef HAVE_STDINT_H
    puts("This environment have <stdint.h>");
#else
    puts("This environment have not <stdint.h>");
#endif
#ifdef HAVE_ASPRINTF
    puts("This environment have asprintf()");
#else
    puts("This environment have not asprintf()");
#endif
#ifdef HAVE_VASPRINTF
    puts("This environment have vasprintf()");
#else
    puts("This environment have not vasprintf()");
#endif
#ifdef HAVE_STRDUP
    puts("This environment have strdup()");
#else
    puts("This environment have not strdup()");
#endif

    return 0;
}


/* End of file */
