/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	BASE:		PRIMARY FUNCTIONS			     */


#ifndef __XC_BASE_H
#define __XC_BASE_H


/* Standard C Library: */
#include <stdarg.h>

/* eXtended C Library: */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


#define text2exit		__xclib(text2exit)
#define get_ansi_color_seq	__xclib(get_ansi_color_seq)
#define panic			__xclib(panic)


struct errmsg
{
    const char *faci;
    const char *file;
    int         line;
    const char *text;

    struct errmsg *next;
};


_CDECL_BEGIN

void puterrmsg(const char *severity, const struct errmsg *list, va_list vargs);

int __xclib(text2exit)(const char *text);

const char *__xclib(get_ansi_color_seq)(const char *color, int foreground);

void __xclib(panic)(void) __noreturn;

_CDECL_END


#endif /* XC BASE HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
