/*  Copyright (C) 1996-2001  Martin Vicente			      -*- c -*-
    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*  XCLIB 0.3	GEOM:		GEOMETRIC COMPUTATION			     */


/*  !!! WARNING !!!    E X P E R I M E N T A L    !!! WARNING !!!  */


#ifndef __XC_GEOM_H
#define __XC_GEOM_H


#ifndef __EXPERIMENTAL__
#warning "<xc/geom.h> is experimental"
#endif


/* eXtended C Library: */
#include <xc/bool.h>		/* BOOLEAN TYPE				     */
#include <xc/cdecl.h>		/* C DECLARATIONS			     */


#if defined _XCLIB_SOURCE || defined _XC_GEOM_SOURCE

#define isinside(x, y, xp, yp, n)	geom_isinside(x, y, xp, yp, n)
#define isinside_l(x, y, xp, yp, n)	geom_isinside_l(x, y, xp, yp, n)
#if defined __GNUC__ && !defined __STRICT_ANSI__
#define isinside_ll(x, y, xp, yp, n)	geom_isinside_ll(x, y, xp, yp, n)
#endif
#define isinside_ff(x, y, xp, yp, n)	geom_isinside_ff(x, y, xp, yp, n)
#define isinside_f(x, y, xp, yp, n)	geom_isinside_f(x, y, xp, yp, n)
#define isinside_fl(x, y, xp, yp, n)	geom_isinside_fl(x, y, xp, yp, n)

#endif


#define geom_isinside(x, y, xp, yp, n)		__xclib(geom_isinside)(x, y, xp, yp, n)
#define geom_isinside_l(x, y, xp, yp, n)	__xclib(geom_isinside_l)(x, y, xp, yp, n)
#if defined __GNUC__ && !defined __STRICT_ANSI__
#define geom_isinside_ll(x, y, xp, yp, n)	__xclib(geom_isinside_ll)(x, y, xp, yp, n)
#endif
#define geom_isinside_ff(x, y, xp, yp, n)	__xclib(geom_isinside_ff)(x, y, xp, yp, n)
#define geom_isinside_f(x, y, xp, yp, n)	__xclib(geom_isinside_f)(x, y, xp, yp, n)
#define geom_isinside_fl(x, y, xp, yp, n)	__xclib(geom_isinside_fl)(x, y, xp, yp, n)


_CDECL_BEGIN

#define	__N unsigned int

#define	__T int
bool __xclib(geom_isinside)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#define	__T long int
bool __xclib(geom_isinside_l)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#if defined __GNUC__ && !defined __STRICT_ANSI__

#define	__T long long int
bool __xclib(geom_isinside_ll)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#endif

#define	__T float
bool __xclib(geom_isinside_ff)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#define	__T double
bool __xclib(geom_isinside_f)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#define	__T long double
bool __xclib(geom_isinside_fl)(__T x, __T y, const __T xpoly[], const __T ypoly[], __N npoints);
#undef	__T

#undef	__N

_CDECL_END


#endif /* XC GEOM HEADER */


/*------------------------------/ END OF FILE /------------------------------*/
