/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : DYNAMIC MULTI-DIMENSIONAL ARRAY
  | Version : 0.3
  | Language: ANSI C
  | File    : dynarr/d1.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#define _FACILITY FACILITY(dynarr)

#include <stddef.h>
#include <stdlib.h>
#include <assert.h>

#include <xc/error.h>

#include "xc/dynarr.h"

#include "global.h"

#define NDIMS	1

typedef int DIM;

void *d1alloc(size_t const size, DIM const dim1)
{
    char *sprite;
    char *arr;

    assert(size > 0 && dim1 > 0);

    sprite = malloc(sizeof (int) + dim1 * size);

    if (sprite == NULL)
    {
	return NULL;
    }

    *(int *)sprite = NDIMS;

    arr = (char *)(sprite + sizeof (int));

    return arr;
}

void d1free(void *const arr)
{
    char *sprite;

    assert(arr != NULL);

    sprite = (char *)arr - sizeof (int);

    assert(*(int *)sprite == NDIMS);

    {
	register char *arr1D = arr;

	assert(arr1D);

	free(sprite);
    }
}


/* End Of File */
