/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : GEOMETRIC COMPUTATION
  | Version : 0.3
  | Language: ANSI C
  | File    : geom/isinside_l.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#define _XCLIB_SOURCE

#define _FACILITY FACILITY(geom)

#include <stddef.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>

#include <xc/mathdefs.h>
#include <xc/macros.h>
#include <xc/bool.h>
#include <xc/error.h>
#include <xc/math.h>

#include "xc/geom.h"

#include "global.h"

#define INTEGER
#define FNAME		__xclib(geom_isinside_l)
#define TYPE		long int
#define Abs(x)		labs(x)
#define ATAN2(y, x)	iatan2l(y, x)

#include "geom/isinside.h"


/* End Of File */
