/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : MISSING FUNCTIONS
  | Version : 0.3
  | Language: ANSI C
  | File    : missing/isnan.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

 [English]

 [French]

 Cette fonction:

   o est incluse dans le standard BSD 4.3 et la norme ISO C 9x;
   o ne fait pas partie des standards ISO C 90 ou POSIX.

\*****************************************************************************/


#define _XCLIB_INTERNALS

#include <math.h>

#ifdef __GLIBC__
#warning "xclib: *** isnan() is already defined in GNU C Library"
#endif

#include "xc/missing.h"

#include "global.h"

#undef isnan

int isnan(double value)
{
    return value != value;
}


/* End Of File */
