/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : MISSING FUNCTIONS
  | Version : 0.3
  | Language: ANSI C
  | File    : missing/strdup.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


/*****************************************************************************\

 [English]

 [French]

 La fonction `strdup()' est prsente sur les systmes BSD. Cette fonction ne
 fait pas partie des standards C ANSI ou POSIX.

\*****************************************************************************/


#define _XCLIB_INTERNALS

#include <stddef.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#ifdef __GLIBC__
#warning "xclib: *** strdup() is already defined in GNU C Library"
#endif

#include "xc/missing.h"

#include "global.h"

#undef strdup

char *strdup(const char *const s)
{
    size_t len;
    char  *new;

    assert(s != NULL);

    len = strlen(s);

    new = malloc(len + 1);

    if (new == NULL) return NULL;

#if 0
    strcpy(new, s);		/* Version classique	*/
#else
    memcpy(new, s, len + 1);	/* Plus efficace	*/
#endif

    return new;
}


/* End Of File */
