/*  XCLIB - a set of C functions for general purposes		      -*- c -*-
    Copyright (C) 1996-2001  Martin Vicente

    This file is part of the eXtended C Library (XCLIB).

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library (see the file COPYING.LIB).
    If not, write to the Free Software Foundation, Inc.,
    59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.		     */


/*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*\
  |  Martin Vicente, 1996-2001
  |
  | Project : XCLIB (eXtended C Library)
  | Purpose : PROTECTED MEMORY ALLOCATION FUNCTIONS
  | Version : 0.3
  | Language: ANSI C
  | File    : xalloc/xstradd.c
  | Author  : Martin VICENTE <martin@vicente.org>
\*|+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|*/


#define _XCLIB_INTERNALS

#define _FACILITY FACILITY(xalloc)

#include <stddef.h>
#include <assert.h>

#include <xc/errors.h>
#include <xc/strlib.h>
#include <xc/error.h>

#include "xc/xalloc.h"

#include "global.h"

#include "xalloc/errors.h"

char *xstradd(char *const s1, const char *const s2)
{
    char *new;

    assert(s1 != NULL && s2 != NULL);

    new = stradd(s1, s2);

    if (new == NULL) error(ERR_STRADD);

    return new;
}

#include "startup.h"
{
    set_exit_status(ERR_STRADD, EXIT_MEMFULL);
}

#include "cleanup.h"
{
    set_exit_status(ERR_STRADD, 0);
}


/* End Of File */
