#include <stddef.h>
#include <stdio.h>
#include <assert.h>

#include "xc/CLList.h"
#include "xc/xalloc.h"

struct node
{
    struct node *next;
    struct node *prev;

    int data;
};

struct list
{
    struct node *link;
};

static void print(struct list *list);

int main()
{
    struct list *list;
    struct node *node1;
    struct node *node2;
    struct node *node3;
    struct node *node4;
    struct node *node5;

    list = xnewrec(struct list);
    _CLL_INIT(list->link);
    print(list);

    (node1 = xnewrec(struct node))->data = 1;
    _CLL_APPEND(list->link, node1);
    print(list);

    (node2 = xnewrec(struct node))->data = 2;
    _CLL_APPEND(list->link, node2);
    print(list);

    (node3 = xnewrec(struct node))->data = 3;
    _CLL_APPEND(list->link, node3);
    print(list);

    (node4 = xnewrec(struct node))->data = 4;
    _CLL_INSERT(list->link, node4);
    print(list);

    (node5 = xnewrec(struct node))->data = 5;
    _CLL_INSERT(list->link, node5);
    print(list);

    _CLL_REMOVE(list->link, node5);
    xfree(node5);
    print(list);

    _CLL_REMOVE(list->link, node3);
    xfree(node3);
    print(list);

    _CLL_ACTION(list->link, xfree(__node););
    xfree(list);

    return 0;
}

static void print(struct list *list)
{
    assert(list != NULL);

    fputs("List: (", stdout);

    if (list->link != NULL)
    {
	printf(" %d", list->link->data);

	_CLL_FOREACH_NODE(list->link,
	{
	    printf(" %d", __node->data);
	});
    }

    puts(" )");
}
