#define _XCLIB_SOURCE

#include <errno.h>
#include <limits.h>
#include <string.h>
#include <stdio.h>
#include <math.h>

#include "xc/macros.h"
#include "xc/timer.h"
#include "xc/xalloc.h"
#include "xc/math.h"

#define WITH_TIMER 0

#if WITH_TIMER
typedef const struct timer *Timer;
#endif

int main()
{
#if 0
    int   *table;
    int    count;
#else
    int    table[] = { -INT_MAX, 1 };
    int    count   = cardinal(table);
#endif
    int    value;
#if WITH_TIMER
    Timer  timer;
#endif
    int    i;

#if 0
    count = 1000;
    table = xmalloc(count * sizeof (int));

    for (i = 0; i < count; i++) table[i] = i;
#endif

#if 0
    _math_flags  = 0;
    _math_flags |= _mathFast;
    _math_flags |= _mathNoRangeChecking;
#endif

#if WITH_TIMER
    timer = timer_ctl(NULL, timerNEW | timerSET);

    for (i = 0; i < 1000; ++i)
    {
#endif
	value = mul(table, count);

#if WITH_TIMER
	timer_ctl(timer, timerTOP);
    }

    timer_ctl(timer, timerPUT | timerDEL);
#endif

    if ((value == INT_MIN || value == INT_MAX) && errno)
	puts(strerror(errno));
    else
	printf("result = %d\n", value);

    return 0;
}
