#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <stdio.h>

#include "xc/time.h"

static void test_add_time(void);
static void test_fix_time(void);

int main()
{
    test_add_time();

    return 0;
}

static void test_add_time(void)
{
    struct timeval t, t2;

    int ret;

    errno = 0;

    t .tv_sec  = +INT32_MAX;
    t .tv_usec = +INT32_MAX;
    t2.tv_sec  = -INT32_MAX;
    t2.tv_usec = -INT32_MAX;

    ret = add_time(&t, &t2);

#ifdef __GLIBC__
    printf("ret = %d (errno = %s)\n", ret, strerror(errno));
#else
    printf("ret = %d (errno = %d)\n", ret, errno);
#endif

    printf("sec = %ld, usec = %ld\n", t.tv_sec, t.tv_usec);
}

static void test_fix_time(void)
{
    struct timeval t;

    int ret;

    t.tv_sec  = 0;
    t.tv_usec = 999999+1;

    errno = 0;

    ret = fix_time(&t);

#ifdef __GLIBC__
    printf("ret = %d (errno = %s)\n", ret, strerror(errno));
#else
    printf("ret = %d (errno = %d)\n", ret, errno);
#endif

    printf("sec = %ld, usec = %ld\n", t.tv_sec, t.tv_usec);
}
