############################################################## -*- makefile -*-
#
#	Copyright (C) 1996-2001  Martin Vicente
#	This file is part of the eXtended C Library (XCLIB).
#
#	This library is free software; you can redistribute it and/or
#	modify it under the terms of the GNU Library General Public
#	License as published by the Free Software Foundation; either
#	version 2 of the License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#	Library General Public License for more details.
#
#	You should have received a copy of the GNU Library General Public
#	License along with this library (see the file COPYING.LIB).
#	If not, write to the Free Software Foundation, Inc.,
#	59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#
###############################################################################
#
#	USAGE TARGET
#
# Warning: This is an include file for GNU makefiles only.
#
#	Project : "Les outils de Martin"
#	Purpose : `usage' target for GNU makefile
#	File    : utils/usage.mk
#	Version : 1.1
#	Language: GNU Make
#	Author  : Martin Vicente
#	Contact : martin@vicente.org (or martin.vicente@free.fr)
#	Revision: Mon, 14 May 2001
#
###############################################################################

ifneq (,)
This makefile requires GNU Make.
endif

ifndef   __UTILS_USAGE_MK
override __UTILS_USAGE_MK := OK

#==============================================================================

override UTILS ?= $(HOME)/devel/utils

include $(UTILS)/color.mk		# DISPLAY COLORIZATION

#====( DEFINITIONS )

define USAGE
endef

#====( RULES )

usage:
	@ $(ECHO_E) $(green)$(call Underline, Usage:)
	@ $(ECHO_E)
	@ $(ECHO_E) "     "$(call Bold, $(MAKE) [OPTIONS] [ENVIRONMENT] [TARGET] ...)
	@ $(ECHO_E)
	@ $(ECHO_E) " Options:"
	@ $(ECHO_E)
	@ $(ECHO_E) "     ""See make (1) manpage or \`make --help'"
	@ $(ECHO_E) $(reset)

.PHONY: usage

#==============================================================================

endif  # __UTILS_USAGE_MK

# [END OF FILE]
